#!/bin/bash
-# Desc: Template to check that apps, files, or dirs exist.
+# Desc: Checks that apps, files, or dirs exist.
#==BEGIN Define script parameters==
declare -Ag appRollCall # Associative array for storing app status
checkapp() {
# Desc: If arg is a command, save result in assoc array 'appRollCall'
# Usage: checkapp arg1 arg2 arg3 ...
- # Version: 0.1.0
+ # Version: 0.1.1
# Input: global assoc. array 'appRollCall'
# Output: adds/updates key(value) to global assoc array 'appRollCall'
+ # Depends: bash 5.0.3
local returnState
- #echo "DEBUG:$(date +%S.%N)..Starting checkapp function."
- #echo "DEBUG:args: $@"
- #echo "DEBUG:returnState:$returnState"
#===Process Args===
for arg in "$@"; do
- #echo "DEBUG:processing arg:$arg"
if command -v "$arg" 1>/dev/null 2>&1; then # Check if arg is a valid command
appRollCall[$arg]="true";
- #echo "DEBUG:appRollCall[$arg]:"${appRollCall[$arg]}
- if ! [ "$returnState" = "false" ]; then returnState="true"; fi
+ if ! [ "$returnState" = "false" ]; then returnState="true"; fi;
else
appRollCall[$arg]="false"; returnState="false";
- fi
- done
-
- #for key in "${!appRollCall[@]}"; do echo "DEBUG:$key => ${appRollCall[$key]}"; done
- #echo "DEBUG:evaluating returnstate. returnState:"$returnState
+ fi;
+ done;
#===Determine function return code===
if [ "$returnState" = "true" ]; then
- #echo "DEBUG:checkapp returns true for $arg";
return 0;
else
- #echo "DEBUG:checkapp returns false for $arg";
return 1;
- fi
+ fi;
} # Check that app exists
checkfile() {
# Desc: If arg is a file path, save result in assoc array 'fileRollCall'
# Usage: checkfile arg1 arg2 arg3 ...
- # Version: 0.1.0
+ # Version: 0.1.1
# Input: global assoc. array 'fileRollCall'
# Output: adds/updates key(value) to global assoc array 'fileRollCall';
# Output: returns 0 if app found, 1 otherwise
+ # Depends: bash 5.0.3
local returnState
#===Process Args===
for arg in "$@"; do
- #echo "DEBUG:processing arg:$arg"
if [ -f "$arg" ]; then
fileRollCall["$arg"]="true";
- #echo "DEBUG:fileRollCall[\"$arg\"]:"${fileRollCall["$arg"]}
- if ! [ "$returnState" = "false" ]; then returnState="true"; fi
+ if ! [ "$returnState" = "false" ]; then returnState="true"; fi;
else
fileRollCall["$arg"]="false"; returnState="false";
- fi
- done
-
- #for key in "${!fileRollCall[@]}"; do echo "DEBUG:fileRollCall key [$key] is:${fileRollCall[$key]}"; done
- #echo "DEBUG:evaluating returnstate. returnState:"$returnState
+ fi;
+ done;
#===Determine function return code===
if [ "$returnState" = "true" ]; then
- #echo "DEBUG:checkapp returns true for $arg";
return 0;
else
- #echo "DEBUG:checkapp returns false for $arg";
return 1;
- fi
+ fi;
} # Check that file exists
checkdir() {
# Desc: If arg is a dir path, save result in assoc array 'dirRollCall'
# Usage: checkdir arg1 arg2 arg3 ...
- # Version 0.1.0
+ # Version 0.1.1
# Input: global assoc. array 'dirRollCall'
# Output: adds/updates key(value) to global assoc array 'dirRollCall';
# Output: returns 0 if app found, 1 otherwise
+ # Depends: Bash 5.0.3
local returnState
#===Process Args===
for arg in "$@"; do
- #echo "DEBUG:processing arg:$arg"
if [ -d "$arg" ]; then
dirRollCall["$arg"]="true";
- #echo "DEBUG:dirRollCall[\"$arg\"]:"${dirRollCall["$arg"]}
if ! [ "$returnState" = "false" ]; then returnState="true"; fi
else
dirRollCall["$arg"]="false"; returnState="false";
fi
done
-
- #for key in "${!dirRollCall[@]}"; do echo "DEBUG:dirRollCall key [$key] is:${dirRollCall[$key]}"; done
- #echo "DEBUG:evaluating returnstate. returnState:"$returnState
#===Determine function return code===
if [ "$returnState" = "true" ]; then
- #echo "DEBUG:checkapp returns true for $arg";
return 0;
else
- #echo "DEBUG:checkapp returns false for $arg";
return 1;
fi
} # Check that dir exists
displayMissing() {
# Desc: Displays missing apps, files, and dirs
# Usage: displayMissing
- # Version 0.1.0
+ # Version 0.1.1
# Input: associative arrays: appRollCall, fileRollCall, dirRollCall
# Output: stderr: messages indicating missing apps, file, or dirs
# Depends: bash 5, checkAppFileDir()
+ local missingApps value appMissing missingFiles fileMissing
+ local missingDirs dirMissing
+
#==BEGIN Display errors==
#===BEGIN Display Missing Apps===
- missingApps="Missing apps :"
+ missingApps="Missing apps :";
#for key in "${!appRollCall[@]}"; do echo "DEBUG:$key => ${appRollCall[$key]}"; done
for key in "${!appRollCall[@]}"; do
- value="${appRollCall[$key]}"
+ value="${appRollCall[$key]}";
if [ "$value" = "false" ]; then
#echo "DEBUG:Missing apps: $key => $value";
- missingApps="$missingApps""$key "
- appMissing="true"
- fi
- done
+ missingApps="$missingApps""$key ";
+ appMissing="true";
+ fi;
+ done;
if [ "$appMissing" = "true" ]; then # Only indicate if an app is missing.
echo "$missingApps" 1>&2;
- fi
+ fi;
+ unset value;
#===END Display Missing Apps===
#===BEGIN Display Missing Files===
- missingFiles="Missing files:"
+ missingFiles="Missing files:";
#for key in "${!fileRollCall[@]}"; do echo "DEBUG:$key => ${fileRollCall[$key]}"; done
for key in "${!fileRollCall[@]}"; do
- value="${fileRollCall[$key]}"
+ value="${fileRollCall[$key]}";
if [ "$value" = "false" ]; then
#echo "DEBUG:Missing files: $key => $value";
- missingFiles="$missingFiles""$key "
- fileMissing="true"
- fi
- done
+ missingFiles="$missingFiles""$key ";
+ fileMissing="true";
+ fi;
+ done;
if [ "$fileMissing" = "true" ]; then # Only indicate if an app is missing.
echo "$missingFiles" 1>&2;
- fi
+ fi;
+ unset value;
#===END Display Missing Files===
#===BEGIN Display Missing Directories===
- missingDirs="Missing dirs:"
+ missingDirs="Missing dirs:";
#for key in "${!dirRollCall[@]}"; do echo "DEBUG:$key => ${dirRollCall[$key]}"; done
for key in "${!dirRollCall[@]}"; do
- value="${dirRollCall[$key]}"
+ value="${dirRollCall[$key]}";
if [ "$value" = "false" ]; then
#echo "DEBUG:Missing dirs: $key => $value";
- missingDirs="$missingDirs""$key "
- dirMissing="true"
- fi
- done
+ missingDirs="$missingDirs""$key ";
+ dirMissing="true";
+ fi;
+ done;
if [ "$dirMissing" = "true" ]; then # Only indicate if an dir is missing.
echo "$missingDirs" 1>&2;
- fi
+ fi;
+ unset value;
#===END Display Missing Directories===
#==END Display errors==